/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "../../libs.h"
#include "../primitive.h"
#include "../texture.h"
#include "../tileset.h"

#define POSITION_DEBUG_FONT_CHARS_MAX 256

/** Struct representing a positionable object in space */
typedef struct {
  primitive_t *primitive;

  spritebatch_t *textBatch;
  texture_t *textTexture;
  tileset_t *textTileset;

  float x, y, z;
  float pitch, yaw, roll;
  float scaleX, scaleY, scaleZ;
} positiondebug_t;