/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "../libs.h"

/** How many actions the queue can hold */
#define POKER_ACTION_QUEUE_SIZE 12

/** How much data (in length of sizeof size_t) each action has available */
#define POKER_ACTION_DATA_SIZE 256

/** Callback for actions to use */
typedef void (*pokerActionCallback)(int32_t index, void *data);

/** Poker Game action that can be queued and executed */
typedef struct {
  pokerActionCallback init;
  pokerActionCallback update;
  pokerActionCallback dispose;
} pokeraction_t;