/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "gametime.h"

gametime_t TIME_STATE;

void gameTimeInit() {
  TIME_STATE.delta = GAMETIME_FIXED_STEP;
  TIME_STATE.last = GAMETIME_FIXED_STEP;
  TIME_STATE.current = GAMETIME_FIXED_STEP + GAMETIME_FIXED_STEP;
}

void gameTimeUpdate(float platformDelta) {
  platformDelta = mathMax(
    mathMin(platformDelta, GAMETIME_FIXED_STEP),
    0
  );

  TIME_STATE.last = TIME_STATE.current;
  TIME_STATE.current = TIME_STATE.current + platformDelta;
  TIME_STATE.delta = TIME_STATE.current - TIME_STATE.last;
  TIME_STATE.fixedDelta = GAMETIME_FIXED_STEP;
}