/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include <dawn/dawn.h>

/**
 * Initializes the gametime global time tracking.
 */
void gameTimeInit();

/**
 * Ticks the current game time.
 * 
 * @param platformDelta The delta step between frames from the platform engine.
 */
void gameTimeUpdate(float platformDelta);